class KCModule

# class KCModule | The base class for control center modules. More...
Definition | `#include <kcmodule.h>`
Inherits | QWidget (qt) [public ]
List of all Methods
Annotated List
Files
Globals
Hierarchy
Index

#### Public Types

- enum Button {Help=1, Default=2, Apply=16, Reset=4, Cancel=8, Ok=32, SysDefault=64 }

#### Public Methods

- KCModule (QWidget *parent=0, const char *name=0, const QStringList &args=QStringList() )
- KCModule (KInstance *instance, QWidget *parent=0, const QStringList &args=QStringList() )
- ~KCModule ()
- virtual void load ()
- virtual void save ()
- virtual void defaults ()
- virtual void sysdefaults ()
- virtual QString quickHelp () const
- virtual const KAboutData * aboutData () const
- int buttons () const
- QString rootOnlyMsg () const
- bool useRootOnlyMsg () const
- KInstance * instance () const

#### Signals

- void changed (bool state)
- void quickHelpChanged ()

#### Protected Methods

- void setButtons (int btn)
- void setRootOnlyMsg (const QString& msg)
- void setUseRootOnlyMsg (bool on)
- virtual void virtual_hook ( int id, void* data )

## Detailed Description

The base class for control center modules.

Starting from KDE 2.0, control center modules are realized as shared libraries that are loaded into the control center at runtime.

The module in principle is a simple widget displaying the item to be changed. The module has a very small interface.

All the necessary glue logic and the GUI bells and whistles are provided by the control center and must not concern the module author.

To write a config module, you have to create a library that contains at one factory function like this:

     #include

     typedef KGenericFactoryQWidget> YourKCModuleFactory;
     K_EXPORT_COMPONENT_FACTORY( yourLibName, YourKCModuleFactory("name_of_the_po_file") );

The parameter "name_of_the_po_file" has to correspond with the messages target that you created in your Makefile.am.

See kdebase/kcontrol/HOWTO for more detailed documentation.

enum Button {Help=1, Default=2, Apply=16, Reset=4, Cancel=8, Ok=32, SysDefault=64 } | ### Button

An enumeration type for the buttons used by this module. You should only use Help, Default and Apply. The rest is obsolete.

See also: buttons, setButtons, KCModule::setButtons

KCModule (QWidget *parent=0, const char *name=0, const QStringList &args=QStringList() ) | ### KCModule

KCModule (KInstance *instance, QWidget *parent=0, const QStringList &args=QStringList() ) | ### KCModule

~KCModule () | ### ~KCModule

void load () | ### load

[virtual]

Load the configuration data into the module.

The load method sets the user interface elements of the module to reflect the current settings stored in the configuration files.

This method is invoked whenever the module should read its configuration (most of the times from a config file) and update the user interface. This happens when the user clicks the "Reset" button in the control center, to undo all of his changes and restore the currently valid settings. NOTE that this is not called after the modules is loaded, so you probably want to call this method in the constructor.

void save () | ### save

[virtual]

Save the configuration data.

The save method stores the config information as shown in the user interface in the config files.

If necessary, this method also updates the running system, e.g. by restarting applications.

save is called when the user clicks "Apply" or "Ok".

void defaults () | ### defaults

[virtual]

Sets the configuration to sensible default values.

This method is called when the user clicks the "Default" button. It should set the display to useful values.

void sysdefaults () | ### sysdefaults

[virtual]

Set the configuration to system default values.

This method is called when the user clicks the "System-Default" button. It should set the display to the system default values.

NOTE: The default behaviour is to call defaults().

QString quickHelp () | ### quickHelp

[const virtual]

Return a quick-help text.

This method is called when the module is docked. The quick-help text should contain a short description of the module and links to the module's help files. You can use QML formating tags in the text.

NOTE: Please make sure the quick help text gets translated (use i18n()).

const KAboutData * aboutData () | ### aboutData

[const virtual]

Returns a the KAboutData for this module This is generally only called for the KBugReport. Override and have it return a pointer to a constant

int buttons () | ### buttons

[const]

Indicate which buttons will be used.

The return value is a value or'ed together from the Button enumeration type.

See also: setButtons

QString rootOnlyMsg () | ### rootOnlyMsg

[const]

Get the RootOnly message for this module.

When the module must be run as root, or acts differently for root and a normal user, it is sometimes useful to customize the message that appears at the top of the module when used as a normal user. This function returns this customized message. If none has been set, a default message will be used.

See also: setRootOnlyMsg

bool useRootOnlyMsg () | ### useRootOnlyMsg

[const]

Tell if KControl should show a RootOnly message when run as a normal user.

In some cases, the module don't want a RootOnly message to appear (for example if it has already one). This function tells KControl if a RootOnly message should be shown

See also: setUseRootOnlyMsg

KInstance * instance () | ### instance

[const]

void changed (bool state) | ### changed

[signal]

Indicate that the state of the modules contents has changed.

This signal is emitted whenever the state of the configuration shown in the module changes. It allows the control center to keep track of unsaved changes.

void quickHelpChanged () | ### quickHelpChanged

[signal]

Indicate that the module's quickhelp has changed.

Emit this signal whenever the module's quickhelp changes. Modules implemented as tabbed dialogs might want to implement per-tab quickhelp for example.

void setButtons (int btn) | ### setButtons

[protected]

Sets the buttons to display.

Help: shows a "Help" button. Default: shows a "Use Defaults" button Apply: in kcontrol this will show an "Apply" and "Reset" button in kcmshell this will show an "Ok", "Apply" and "Cancel" button

If Apply is not specified, kcmshell will show a "Close" button.

See also: buttons

void setRootOnlyMsg (const QString& msg) | ### setRootOnlyMsg

[protected]

Sets the RootOnly message.

This message will be shown at the top of the module of the corresponding desktop file contains the line X-KDE-RootOnly=true. If no message is set, a default one will be used.

See also: KCModule::rootOnlyMessage

void setUseRootOnlyMsg (bool on) | ### setUseRootOnlyMsg

[protected]

Change wether or not the RootOnly message should be shown.

Following the value of `on`, the RootOnly message will be shown or not.

See also: useRootOnlyMsg

void virtual_hook ( int id, void* data ) | ### virtual_hook

[protected virtual]

- Author: Matthias Hoelzer-Kluepfel
- Generated: root on macppc.ports.openbsd.org on Sat Sep 6 10:36:37 2003, using kdoc 2.0a54.